CodeForces - 982C Cut 'em all!

Discription

You're given a tree with nn vertices.

Your task is to determine the maximum possible number of edges that can be removed in such a way that all the remaining connected components will have even size.

Input

The first line contains an integer nn (1n1051≤n≤105) denoting the size of the tree.

The next n1n−1 lines contain two integers uu, vv (1u,vn1≤u,v≤n) each, describing the vertices connected by the ii-th edge.

It's guaranteed that the given edges form a tree.

Output

Output a single integer kk — the maximum number of edges that can be removed to leave all connected components with even size, or 1−1 if it is impossible to remove edges in order to satisfy this property.

Examples

Input
4
2 4
4 1
3 1
Output
1
Input
3
1 2
1 3
Output
-1
Input
10
7 1
8 4
8 10
4 7
6 5
9 3
3 5
2 10
2 5
Output
4
Input
2
1 2
Output
0

Note

In the first example you can remove the edge between vertices 11 and 44. The graph after that will have two connected components with two vertices in each.

In the second example you can't remove edges in such a way that all components have even number of vertices, so the answer is 1−1.

     题意大概就是问你最多可以割多少条边(在一棵树上),使得剩余的所有联通块的size都是偶数。。。

     显然,如果n是奇数的话,一刀都切不了啊,因为奇数必定=奇数+偶数。

     n是偶数的话,那就随便dfs贪心一下,每次遍历完一个点的时候(一定是深度大的优先),如果size已经是偶数,那么直接割掉。

    虽然不是很会证明这种贪心,但是根据我学OI多年的经验这个贪心应该是很靠谱的23333

#include<bits/stdc++.h>
#define ll long long
using namespace std;
const int maxn=100005;
int hd[maxn],ne[maxn*2],to[maxn*2],num,n,siz[maxn],ans;
inline void add(int x,int y){ to[++num]=y,ne[num]=hd[x],hd[x]=num;}

void dfs(int x,int fa){
	siz[x]=1;
	for(int i=hd[x];i;i=ne[i]) if(to[i]!=fa){
		dfs(to[i],x);
		siz[x]+=siz[to[i]];
	}
	
	if(!(siz[x]&1)) siz[x]=0,ans++;
}

int main(){
	scanf("%d",&n);
	int uu,vv;
	for(int i=1;i<n;i++){
		scanf("%d%d",&uu,&vv);
		add(uu,vv),add(vv,uu);
	}
	
	if(n&1){ puts("-1"); return 0;}
	
	dfs(1,-1),ans--;
	
	printf("%d\n",ans);
	return 0;
}

  

猜你喜欢

转载自www.cnblogs.com/JYYHH/p/9055195.html
今日推荐